/*****************************************************************
 * Copyright (c) ParaSoft Corporation 1991.  All rights reserved.*
 * THIS IS UNPUBLISHED PROPRIETARY SOURCE CODE OF ParaSoft       *
 * The copyright notice above does not evidence any              *
 * actual or intended publication of such source code.           *
 *****************************************************************/

#include "extern.h"

write_FunctionStmt (node)
Node *node;
{
	struct S_FunctionStmt *stmt = &node->FunctionStmt;
	Node *name, *namelist, *temp;
	Node *list = stmt->OptNameList;
	T_Entry *funentry, *entry;
	char *funname = stmt->Name->com.str;

	funentry = lookup_user (funname);

	if (IS_array (funentry)) {
		oSUBROUTINE ();
		onam (fun_name (funname));
		ochb ('(');
		onam (funname);
		if (IS_automatic (funentry)) {
			ochb (',');
			onam (auto_name (funname));
		}
		if (IS_assumed_shape (funentry)) {
			ochb (',');
			onam (desc_name (funname));
		}
		if (list != NN)
			ochb (',');
	}
	else {
		write_pass (stmt->opt31);

		oFUNCTION ();
		onam (funname);
		ochb ('(');
	}

	if (list != NN) {
		namelist = list_invert (list);
		for (LIST_LOOP (name, namelist, temp)) {
			if (!LIST_FIRST (name, namelist))
				ochb (',');
			write_pass (name);

			if ((entry = lookup (name->com.str, TAB_LOCAL)) != (T_Entry*) 0) {
				if (IS_optional (entry)) {
					ochb (',');
					onam (opt_name (name->com.str));
				}
				if (IS_assumed_shape (entry)) {
					ochb (',');
					onam (desc_name (name->com.str));
				}
			}
		}
	}

	ochb (')');
}

write_EntryStmt (node)
Node *node;
{
	write_pass_childs (node);
	odon ();
	oend ();
	ostart ();
	desc_init ();
}

write_SubroutineStmt (node)
Node *node;
{
	struct S_SubroutineStmt *stmt = &node->SubroutineStmt;
	Node *name, *namelist, *temp;
	Node *list = stmt->OptDummyArgList;
	T_Entry *entry;
	char *funname = stmt->Name->com.str;

	oSUBROUTINE ();
	onam (funname);

	if (list == NN)
		return;

	ochb ('(');

	if (list != NN) {
		namelist = list_invert (list);
		for (LIST_LOOP (name, namelist, temp)) {
			if (!LIST_FIRST (name, namelist))
				ochb (',');

			if (name->com.str == (char*) 0)
				name->com.str = "*";

			write_pass (name);

			if ((entry = lookup (name->com.str, TAB_LOCAL)) != (T_Entry*) 0) {
				if (IS_optional (entry)) {
					ochb (',');
					onam (opt_name (name->com.str));
				}
				if (IS_assumed_shape (entry)) {
					ochb (',');
					onam (desc_name (name->com.str));
				}
			}
		}
	}

	ochb (')');
}

#define use_interface		1
#define use_not_defined		3

write_args (funentry, sublist, icase)
T_Entry *funentry;
Node *sublist;
int icase;
{
        Node *sub, *temp;
        Node *expr, *expr1,*sub1;
        int optional;
        for (LIST_LOOP (sub, sublist, temp)) {
/* ##BEGIN##, 03/15/1992, ZEKI */
/* Not to write .TRUE. and .FALSE. if attr_npac_intrinsic and also
   if parameter  is optional and next one is .FALSE. not write that
   parameter too */
                sub1=NN;optional=0;
                if(!LIST_LAST(temp)) sub1=temp->lst.next->lst.value;
                if(IS_npac_intrinsic(funentry)){
                           expr=sub->Subscript.Expr;
                           if((!expr->com.str)
                              ||(strcmp(expr->com.str,".TRUE.")
                              &&strcmp(expr->com.str,".FALSE."))){
                                   if(sub1!=NN){
                                       expr1=sub1->Subscript.Expr;
                                       if(expr1->com.str)
                                         if(!strcmp(expr1->com.str,".FALSE."))
                                                optional=1;
                                     }
                                   if(!optional){
                                        if (!LIST_FIRST (sub, sublist))
                                           ochb (',');
                                fun_subscript_output (sub, funentry, 1, 0);
                                 }
                                 }
                            }
                else  {
                        if (!LIST_FIRST (sub, sublist))
                                ochb (',');
                        fun_subscript_output (sub, funentry, 1, 0);
                      }

          }

}
/* ##END## */


write_FunctionReference (node)
Node *node;
{
	struct S_FunctionReference *fun = &node->FunctionReference;
	int num;
	T_Entry *entry, *entry1, *funentry = fun->entry;
	char *name = node->FunctionReference.Name->com.str;
	int icase;

/* Beg: To deal with array stuff */

    T_Entry *arr_entry;
    int array_current_bef;

    if ((arr_entry = lookup_glo (node->com.str)) != TN && IS_elemental (arr_entry))
        U_stack_push_inside (INSIDE_ELEMENTAL);
    else
        array_current_bef = e_array_current;

/* End: To deal with array stuff */

	if (funentry == TN)
		icase = use_not_defined;
	else if (funentry->interf != (Interf*) 0 && IS_explicit (funentry))
		icase = use_interface;
	else
		icase = use_not_defined;

	switch (icase) {

	case use_interface:
	case use_not_defined:
		if (funentry != TN && IS_array (funentry)) {
			oCALL ();
                        if(!IS_npac_intrinsic(funentry))
          			onam (fun_name (name)); 
                        else
			        onam (name); 
			ochb ('(');
                        /* ZEKI */
                       /* this is to write RESULT temporary of 
                          npac_intrinsic at the end of parameter list */
                        if(!IS_npac_intrinsic(funentry))
                        	onam (fun->temp->com.str);
/* ##BEGIN##, 02/23/1992, ZEKI */
/* Not the write descriptor and auto name for the output of intrinsic */
/*
			if (IS_automatic (funentry)) {
				ochb (',');
				onam (auto_name (fun->temp->com.str));
			}
			if (IS_assumed_pass (funentry)) {
				ochb (',');
				onam (desc_name (fun->temp->com.str));
			}
			if (fun->SubscriptList != NN)
				ochb (',');
*/
/* ##END## */
		}
		else {
			onam (name);
			ochb ('(');
		}

		write_args (funentry, fun->SubscriptList, icase);
/* ##BEGIN##, 03/15/1992, ZEKI */
/* to write RESULT and PROCLIST at the end of parameter list
   if attr_npac_intrinsic */
                if(IS_npac_intrinsic(funentry)){
                         if(fun->temp!=NN){
                          ochb(',');
                          onam (fun->temp->com.str);
                          write_lb_ub(fun->temp->com.str);
                          entry1=lookup_loc(fun->temp->com.str);
                          if(entry1->typ->shape!=SN){
                               ochb (',');
                               onam (desc_name (fun->temp->com.str));
			     }
			}
                          ostr(", proclist"); 
                        }
/* ##END## */
		ochb (')');
		break;

#ifdef CHECK
	default:
		SYSERR;
#endif
	}

/* Beg: To deal with array stuff */

    if (arr_entry != TN && IS_elemental (arr_entry))
        U_stack_pop_inside ();
    else
        e_array_current = array_current_bef;

/* End: To deal with array stuff */
}

/* BOZKUS */
/* this part is to write lover and ubber bound of A array by using
   A_info(1,X) and A_info(2,X) 
   Note : I will write A_info(3,X) and A_info(4,X) when I include
   overlap area.
*/
write_lb_ub(name)
char *name;
{
  T_Entry *entry;
  int i;

  entry=lookup_loc(name);
  if(entry->typ->shape!=SN){
            for(i=0; i<RANK_FROM_SHAPE(entry->typ->shape); i++){
        		  ochb (',');
			  onam (desc_name (name));
                          ostr("(1,");
                          oint((long) i+1);              
        		  ochb (')');

                          ochb (',');
			  onam (desc_name (name));
                          ostr("(2,");
                          oint((long) i+1);              
        		  ochb (')');
			}
                          
	  }
}
write_CallStmt (node)
Node *node;
{
	T_Entry *funentry;
	int icase;
	Node *sublist = node->CallStmt.SubscriptList;
	char *name = node->CallStmt.Name->com.str;

/* Beg: To deal with array stuff */

        T_Entry *entry;

        if ((entry = lookup_user (node->com.str)) != TN && IS_elemental (entry))
            U_stack_push_inside (INSIDE_ELEMENTAL);

/* End: To deal with array stuff */

	if ((funentry = lookup_user (name)) == TN)
		icase = use_not_defined;
	else if (funentry->interf != (Interf*) 0 && IS_explicit (funentry))
		icase = use_interface;
	else
		icase = use_not_defined;

	switch (icase) {

	case use_interface:
	case use_not_defined:
		ostr ("CALL");
		onam (name);
		ochb ('(');

		write_args (funentry, sublist, icase);

		ochb (')');
		break;

#ifdef CHECK
	default:
		SYSERR;
#endif
	}

/* Beg: To deal with array stuff */

    if (entry != TN && IS_elemental (entry)) {
         U_stack_pop_inside ();
         if (node->com.typ->shape != (Shape*) 0)
             e_array_current = e_array_current;
	}

/* End: To deal with array stuff */
}

write_one_dim_gen (arr, is_auto)  /* arr (x) -> arr (Tarr_auto + x - lb) */
Node *arr;
int is_auto;
{
	Node *sub, *sublist = list_invert (arr->ArraySection.SubscriptList), *temp;
	int num, i;
	char *name = arr->com.str;
	T_Entry *entry = lookup_loc (name);
	Shape *shape = entry->typ->shape;

	onam (arr->com.str);
	ochb ('(');

	num = 0;
	for (LIST_LOOP (sub, sublist, temp)) {
		if (num) {
			ochb ('+');
			write_pass (make_DumExpr_1_PIN (shape->extent[num - 1]));
			ostr ("* (");
		}
		else {
			if (is_auto) {
				onam (auto_name (name));
				ochb ('+');
			}
			else {
				if (shape->sizes0 [num] != Node_1)
					ostr ("1 +");
			}
		}

		sub->Subscript.Expr = make_DumExpr_1_PIN(sub->Subscript.Expr);
		write_pass (sub);
		if (is_auto || num || shape->sizes0 [num] != Node_1) {
			ochb ('-');
			write_pass (make_DumExpr_1_PIN (shape->sizes0[num]));
		}
		
		num++;
	}

	for (i = 0; i < num; i++)
		ochb (')');
}

write_one_dim (arr)
Node *arr;
{
	write_one_dim_gen (arr, 1);
}

write_one_dim_no_auto (arr)
Node *arr;
{
	write_one_dim_gen (arr, 0);
}

/******************************** C H E C K **************************************/

static unmatched_error (unit)
char *unit;
{
	sprintf (serr, "unmatched END %s statement", unit);
	fatal (serr);
}

static unmatched_name_error (lunit, uunit)
char *lunit, *uunit;
{
	sprintf (serr, "%s-name in END %s doesn't match the one in %s", lunit, uunit, uunit);
	fatal (serr);
}

Node *check_EndProgramStmt (node)
Node *node;
{
	Node *name, *end_name;

	if (se_unit_stmt != NN) {
		if (se_unit_stmt->com.type != PROGRAM_STMT) {
			unmatched_error ("PROGRAM");
			return node;  /* R E T U R N */
		}

		if ((end_name = node->EndProgramStmt.Name) != NN) {
			name = se_unit_stmt->ProgramStmt.Name;

			if (U_strcmp_nocase (name->com.str, end_name->com.str))
				unmatched_name_error ("program", "PROGRAM");
		}
	}

	return node;
}

Node *check_EndSubroutineStmt (node)
Node *node;
{
	Node *name, *end_name;

	if (se_unit_stmt != NN) {
		if (se_unit_stmt->com.type != SUBROUTINE_STMT) {
			unmatched_error ("SUBROUTINE");
			return node;  /* R E T U R N */
		}

		if ((end_name = node->EndSubroutineStmt.Name) != NN) {
			name = se_unit_stmt->SubroutineStmt.Name;

			if (U_strcmp_nocase (name->com.str, end_name->com.str))
				unmatched_name_error ("subroutine", "SUBROUTINE");
		}
	}

	return node;
}

Node *check_EndFunctionStmt (node)
Node *node;
{
	Node *name, *end_name;

	if (se_unit_stmt != NN) {
		if (se_unit_stmt->com.type != FUNCTION_STMT) {
			unmatched_error ("FUNCTION");
			return node;  /* R E T U R N */
		}

		if ((end_name = node->EndFunctionStmt.Name) != NN) {
			name = se_unit_stmt->FunctionStmt.Name;

			if (U_strcmp_nocase (name->com.str, end_name->com.str))
				unmatched_name_error ("function", "FUNCTION");
		}
	}

	return node;
}

Node *check_EndModuleStmt (node)
Node *node;
{
	Node *name, *end_name;

	if (se_unit_stmt != NN) {
		if (se_unit_stmt->com.type != MODULE_STMT) {
			unmatched_error ("MODULE");
			return node;  /* R E T U R N */
		}

		if ((end_name = node->EndModuleStmt.Name) != NN) {
			name = se_unit_stmt->ModuleStmt.Name;

			if (U_strcmp_nocase (name->com.str, end_name->com.str))
				unmatched_name_error ("module", "MODULE");
		}
	}

/*
	module_EndModuleStmt (node);
*/

	return node;
}

Node *check_EndBlockDataStmt (node)
Node *node;
{
	Node *name, *end_name;

	if (se_unit_stmt != NN) {
		if (se_unit_stmt->com.type != BLOCK_DATA_STMT) {
			unmatched_error ("BLOCK DATA");
			return node;  /* R E T U R N */
		}

		if ((end_name = node->EndBlockDataStmt.Name) != NN) {
			name = se_unit_stmt->BlockDataStmt.Name;

			if (U_strcmp_nocase (name->com.str, end_name->com.str))
				unmatched_name_error ("block-data", "BLOCK DATA");
		}
	}

	return node;
}

/******************************** T R A N S **************************************/
/******************************** W R I T E **************************************/
